Index: /code/branches/core4/src/core/CorePrereqs.h
===================================================================
--- /code/branches/core4/src/core/CorePrereqs.h	(revision 3273)
+++ /code/branches/core4/src/core/CorePrereqs.h	(revision 3274)
@@ -176,15 +176,18 @@
     class HalfAxis;
     class InputBuffer;
+    class InputDevice;
+    template <class Traits>
+    class InputDeviceTemplated;
+    class InputHandler;
     class InputManager;
     class InputState;
     class JoyStick;
-    class JoyStickHandler;
-    class MouseHandler;
+    class Mouse;
+    class Keyboard;
     class KeyBinder;
     class KeyDetector;
-    class KeyHandler;
     class ParamCommand;
     class SimpleCommand;
-    class SimpleInputState;
+
 }
 
Index: /code/branches/core4/src/core/OrxonoxClass.h
===================================================================
--- /code/branches/core4/src/core/OrxonoxClass.h	(revision 3273)
+++ /code/branches/core4/src/core/OrxonoxClass.h	(revision 3274)
@@ -40,4 +40,5 @@
 #include "CorePrereqs.h"
 #include <set>
+#include <vector>
 
 namespace orxonox
Index: /code/branches/core4/src/core/input/Button.h
===================================================================
--- /code/branches/core4/src/core/input/Button.h	(revision 3273)
+++ /code/branches/core4/src/core/input/Button.h	(revision 3274)
@@ -36,5 +36,5 @@
 #define _Button_H__
 
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 
 #include <string>
Index: /code/branches/core4/src/core/input/CMakeLists.txt
===================================================================
--- /code/branches/core4/src/core/input/CMakeLists.txt	(revision 3273)
+++ /code/branches/core4/src/core/input/CMakeLists.txt	(revision 3274)
@@ -5,8 +5,10 @@
   InputCommands.cc
   InputManager.cc
+  InputState.cc
   JoyStick.cc
-  JoyStickDeviceNumberListener.cc
+  JoyStickQuantityListener.cc
   KeyBinder.cc
+  Keyboard.cc
   KeyDetector.cc
-  SimpleInputState.cc
+  Mouse.cc
 )
Index: /code/branches/core4/src/core/input/HalfAxis.h
===================================================================
--- /code/branches/core4/src/core/input/HalfAxis.h	(revision 3273)
+++ /code/branches/core4/src/core/input/HalfAxis.h	(revision 3274)
@@ -36,5 +36,5 @@
 #define _HalfAxis_H__
 
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 
 #include "Button.h"
Index: /code/branches/core4/src/core/input/InputBuffer.cc
===================================================================
--- /code/branches/core4/src/core/input/InputBuffer.cc	(revision 3273)
+++ /code/branches/core4/src/core/input/InputBuffer.cc	(revision 3274)
@@ -184,12 +184,12 @@
 
 
-    void InputBuffer::processKey(const KeyEvent &evt)
-    {
-        if (evt.isModifierDown(KeyboardModifier::Alt) && evt.key == KeyCode::Tab)
+    void InputBuffer::processKey(const KeyEvent& evt)
+    {
+        if (evt.isModifierDown(KeyboardModifier::Alt) && evt.getKeyCode() == KeyCode::Tab)
             return;
 
         for (std::list<BaseInputBufferListenerTuple*>::iterator it = this->listeners_.begin(); it != this->listeners_.end(); ++it)
         {
-            if ((*it)->trueKeyFalseChar_ && ((*it)->key_ == evt.key))
+            if ((*it)->trueKeyFalseChar_ && ((*it)->key_ == evt.getKeyCode()))
                 (*it)->callFunction();
         }
@@ -197,9 +197,9 @@
         if (evt.isModifierDown(KeyboardModifier::Ctrl))
         {
-            if (evt.key == KeyCode::V)
+            if (evt.getKeyCode() == KeyCode::V)
                 this->insert(fromClipboard());
-            else if (evt.key == KeyCode::C)
+            else if (evt.getKeyCode() == KeyCode::C)
                 toClipboard(this->buffer_);
-            else if (evt.key == KeyCode::X)
+            else if (evt.getKeyCode() == KeyCode::X)
             {
                 toClipboard(this->buffer_);
@@ -209,7 +209,7 @@
         else if (evt.isModifierDown(KeyboardModifier::Shift))
         {
-            if (evt.key == KeyCode::Insert)
+            if (evt.getKeyCode() == KeyCode::Insert)
                 this->insert(fromClipboard());
-            else if (evt.key == KeyCode::Delete)
+            else if (evt.getKeyCode() == KeyCode::Delete)
             {
                 toClipboard(this->buffer_);
@@ -218,5 +218,5 @@
         }
 
-        this->insert((char)evt.text);
+        this->insert((char)evt.getText());
     }
 
@@ -225,5 +225,5 @@
         @param dt Delta time
     */
-    void InputBuffer::updateInput(float dt)
+    void InputBuffer::keyboardUpdated(float dt)
     {
         timeSinceKeyPressed_ += dt;
@@ -239,7 +239,7 @@
     }
 
-    void InputBuffer::keyPressed(const KeyEvent &evt)
-    {
-        lastKey_ = evt.key;
+    void InputBuffer::buttonPressed(const KeyEvent& evt)
+    {
+        lastKey_ = evt.getKeyCode();
         timeSinceKeyPressed_ = 0.0;
         timeSinceKeyRepeated_ = keyRepeatDeleay_;
@@ -249,7 +249,7 @@
     }
 
-    void InputBuffer::keyHeld(const KeyEvent& evt)
-    {
-        if (evt.key == lastKey_)
+    void InputBuffer::buttonHeld(const KeyEvent& evt)
+    {
+        if (evt.getKeyCode() == lastKey_)
         {
             while (keysToRepeat_)
Index: /code/branches/core4/src/core/input/InputBuffer.h
===================================================================
--- /code/branches/core4/src/core/input/InputBuffer.h	(revision 3273)
+++ /code/branches/core4/src/core/input/InputBuffer.h	(revision 3274)
@@ -30,10 +30,10 @@
 #define _InputBuffer_H__
 
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 
 #include <list>
 #include <string>
 #include "core/OrxonoxClass.h"
-#include "InputInterfaces.h"
+#include "InputHandler.h"
 
 namespace orxonox
@@ -74,5 +74,5 @@
     };
 
-    class _CoreExport InputBuffer : public KeyHandler, public OrxonoxClass
+    class _CoreExport InputBuffer : public InputHandler, public OrxonoxClass
     {
         public:
@@ -165,11 +165,9 @@
             bool charIsAllowed(const char& input);
 
-            void keyPressed (const KeyEvent& evt);
-            void keyReleased(const KeyEvent& evt) { }
-            void keyHeld    (const KeyEvent& evt);
-            void processKey (const KeyEvent &e);
+            void buttonPressed(const KeyEvent& evt);
+            void buttonHeld   (const KeyEvent& evt);
+            void processKey   (const KeyEvent& evt);
 
-            void updateInput(float dt);
-            void updateKey(float dt) { }
+            void keyboardUpdated(float dt);
 
             std::string buffer_;
Index: /code/branches/core4/src/core/input/InputCommands.h
===================================================================
--- /code/branches/core4/src/core/input/InputCommands.h	(revision 3273)
+++ /code/branches/core4/src/core/input/InputCommands.h	(revision 3274)
@@ -36,5 +36,5 @@
 #define _InputCommands_H__
 
-#include "core/CorePrereqs.h"
+#include "InputPrereqs.h"
 #include "core/CommandEvaluation.h"
 
Index: /code/branches/core4/src/core/input/InputDevice.h
===================================================================
--- /code/branches/core4/src/core/input/InputDevice.h	(revision 3274)
+++ /code/branches/core4/src/core/input/InputDevice.h	(revision 3274)
@@ -0,0 +1,215 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief 
+*/
+
+#ifndef _InputDevice_H__
+#define _InputDevice_H__
+
+#include "InputPrereqs.h"
+
+#include <vector>
+#include <boost/foreach.hpp>
+#include <ois/OISInputManager.h>
+
+#include "util/Debug.h"
+#include "core/Clock.h"
+// TODO: Try to remove this
+#include "InputManager.h"
+#include "InputState.h"
+
+namespace orxonox
+{
+    /**
+    @brief
+    */
+    class InputDevice
+    {
+        friend class InputManager;
+
+    public:
+        InputDevice(unsigned int id) : bCalibrating_(false), id_(id) { }
+        virtual ~InputDevice() { }
+        virtual std::string getClassName() = 0;
+        virtual void update(const Clock& time) = 0;
+        virtual void clearBuffers() = 0;
+
+        void startCalibration()
+        {
+            bCalibrating_ = true;
+            this->calibrationStarted();
+        }
+
+        void stopCalibration()
+        {
+            this->calibrationStopped();
+            bCalibrating_ = false;
+        }
+
+        unsigned int getDeviceID() { return this->id_; }
+
+    protected:
+        virtual void calibrationStarted() { }
+        virtual void calibrationStopped() { }
+        bool isCalibrating() { return bCalibrating_; }
+
+        // InputState handling
+        std::vector<InputState*> inputStates_;
+
+    private:
+        InputDevice(const InputDevice& rhs);
+
+        std::vector<InputState*>& getStateListRef()
+        {
+            return this->inputStates_;
+        }
+
+        bool bCalibrating_;
+        const unsigned int id_;
+    };
+
+    /**
+    @brief
+    */
+    template <class Traits>
+    class InputDeviceTemplated : public InputDevice
+    {
+        typedef typename Traits::DeviceClass DeviceClass;
+        typedef typename Traits::OISDeviceClass OISDeviceClass;
+        typedef typename Traits::ButtonType ButtonType;
+        typedef typename Traits::ButtonTypeParam ButtonTypeParam;
+        static const OIS::Type OISDeviceValue = Traits::OISDeviceValue;
+
+    public:
+        InputDeviceTemplated(unsigned int id)
+            : InputDevice(id)
+        {
+            OIS::InputManager* system = InputManager::getInstance().getInputSystem();
+            oisDevice_ = static_cast<OISDeviceClass*>(system->createInputObject(OISDeviceValue, true));
+            oisDevice_->setEventCallback(static_cast<DeviceClass*>(this));
+            COUT(4) << "Instantiated a " << this->getClassName() << std::endl;
+        }
+
+        virtual ~InputDeviceTemplated()
+        {
+            try
+            {
+                InputManager::getInstance().getInputSystem()->destroyInputObject(oisDevice_);
+            }
+            catch (...)
+            {
+                COUT(1) << this->getClassName() << " destruction failed! Potential resource leak!" << std::endl;
+            }
+        }
+
+        OISDeviceClass* getOISDevice()
+        {
+            return this->oisDevice_;
+        }
+
+        std::string getClassName()
+        {
+            return InputDeviceNames::values[OISDeviceValue];
+        }
+
+        void update(const Clock& time)
+        {
+            oisDevice_->capture();
+
+            if (!this->isCalibrating())
+            {
+                // Call all the states with the held button event
+                for (unsigned int iB = 0; iB < pressedButtons_.size(); ++iB)
+                    for (unsigned int iS = 0; iS < inputStates_.size(); ++iS)
+                        inputStates_[iS]->buttonEvent<ButtonEvent::THold, Traits>(
+                            this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(pressedButtons_[iB]));
+
+                // Call states with device update events
+                for (unsigned int i = 0; i < inputStates_.size(); ++i)
+                    inputStates_[i]->update(time.getDeltaTime(), this->getDeviceID());
+            }
+
+            static_cast<DeviceClass*>(this)->updateImpl(time);
+        }
+
+        void clearBuffers()
+        {
+            pressedButtons_.clear();
+            static_cast<DeviceClass*>(this)->clearBuffersImpl();
+        }
+
+    protected:
+        void buttonPressed(ButtonTypeParam button)
+        {
+            // check whether the button already is in the list (can happen when focus was lost)
+            unsigned int iButton = 0;
+            while (iButton < pressedButtons_.size() && pressedButtons_[iButton] != button)
+                iButton++;
+            if (iButton == pressedButtons_.size())
+                pressedButtons_.push_back(button);
+            else
+                return; // Button already pressed
+
+            // Call states
+            for (unsigned int i = 0; i < inputStates_.size(); ++i)
+                inputStates_[i]->buttonEvent<ButtonEvent::TPress, Traits>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
+        }
+
+        void buttonReleased(ButtonTypeParam button)
+        {
+            // remove the button from the pressedButtons_ list
+            for (unsigned int iButton = 0; iButton < pressedButtons_.size(); iButton++)
+            {
+                if (pressedButtons_[iButton] == button)
+                {
+                    pressedButtons_.erase(pressedButtons_.begin() + iButton);
+                    break;
+                }
+            }
+
+            // Call states
+            for (unsigned int i = 0; i < inputStates_.size(); ++i)
+                inputStates_[i]->buttonEvent<ButtonEvent::TRelease, Traits>(this->getDeviceID(), static_cast<DeviceClass*>(this)->getButtonEventArg(button));
+        }
+
+        OISDeviceClass* oisDevice_;
+
+    private:
+        void clearBuffersImpl() { } //!< Fallback dummy function for static polymorphism
+        void updateImpl(const Clock& time) { } //!< Fallback dummy function for static polymorphism
+        //!< Fallback dummy function for static polymorphism
+        ButtonType& getButtonEventArg(ButtonType& button) { return button; }
+
+        std::vector<ButtonType> pressedButtons_;
+    };
+}
+
+#endif /* _InputDevice_H__ */
Index: /code/branches/core4/src/core/input/InputHandler.h
===================================================================
--- /code/branches/core4/src/core/input/InputHandler.h	(revision 3274)
+++ /code/branches/core4/src/core/input/InputHandler.h	(revision 3274)
@@ -0,0 +1,89 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Declarations of various interface classes for the input management.
+*/
+
+#ifndef _InputHandler_H__
+#define _InputHandler_H__
+
+#include "InputPrereqs.h"
+#include "util/Math.h"
+
+namespace orxonox
+{
+    /**
+    @brief
+    */
+    class _CoreExport InputHandler
+    {
+    public:
+        virtual ~InputHandler() { }
+
+        template<class T> void buttonEvent(unsigned int device, const T& button, ButtonEvent::TPress)
+            { this->buttonPressed(button); }
+        template<class T> void buttonEvent(unsigned int device, const T& button, ButtonEvent::TRelease)
+            { this->buttonReleased(button); }
+        template<class T> void buttonEvent(unsigned int device, const T& button, ButtonEvent::THold)
+            { this->buttonHeld(button); }
+        void buttonEvent(unsigned int device, JoyStickButtonCode::ByEnum button, ButtonEvent::TPress)
+            { this->buttonPressed(device - InputDeviceEnumerator::FirstJoyStick, button); }
+        void buttonEvent(unsigned int device, JoyStickButtonCode::ByEnum button, ButtonEvent::TRelease)
+            { this->buttonReleased(device - InputDeviceEnumerator::FirstJoyStick, button); }
+        void buttonEvent(unsigned int device, JoyStickButtonCode::ByEnum button, ButtonEvent::THold)
+            { this->buttonHeld(device - InputDeviceEnumerator::FirstJoyStick, button); }
+
+        virtual void buttonPressed (const KeyEvent& evt) { }
+        virtual void buttonReleased(const KeyEvent& evt) { }
+        virtual void buttonHeld    (const KeyEvent& evt) { }
+
+        virtual void buttonPressed (MouseButtonCode::ByEnum button) { }
+        virtual void buttonReleased(MouseButtonCode::ByEnum button) { }
+        virtual void buttonHeld    (MouseButtonCode::ByEnum button) { }
+        virtual void mouseMoved    (IntVector2 abs, IntVector2 rel, IntVector2 clippingSize) { }
+        virtual void mouseScrolled (int abs, int rel) { }
+
+        virtual void buttonPressed (unsigned int joyStick, JoyStickButtonCode::ByEnum button) { }
+        virtual void buttonReleased(unsigned int joyStick, JoyStickButtonCode::ByEnum button) { }
+        virtual void buttonHeld    (unsigned int joyStick, JoyStickButtonCode::ByEnum button) { }
+        virtual void axisMoved     (unsigned int joyStick, unsigned int axis, float value){ }
+
+        virtual void keyboardUpdated(float dt) { }
+        virtual void mouseUpdated   (float dt) { }
+        virtual void joyStickUpdated(unsigned int joyStick, float dt) { }
+
+        virtual void allDevicesUpdated(float dt) { }
+
+        static InputHandler EMPTY;
+    };
+}
+
+#endif /* _InputHandler_H__ */
